fs=1;
N=8;

P=1;
y1 = create_prbs(0, 1, 0, N, P, 2^N*P, 0);
NFFT=2^N;
wind=hanning(NFFT/2);
overlap=NFFT/4;
[Py,f]=psd(y1,NFFT,fs,wind,overlap);
mag=10*log10(Py);
subplot(3,1,1),plot(f,mag,'k','linewidth',2);
title('a) PRBS Spectrum: N = 8, p = 1','FontSize',12,'FontWeight','Bold')
set(gca,'XTick',[0.05 0.1 0.15 0.2 0.25 0.30 0.35 0.40 0.45 0.5])
set(gca,'XTickLabel',{'0.05', '0.10', '0.15', '0.20', '0.25', '0.30', '0.35', '0.40','0.45', '0.5'},'FontSize',10,'FontWeight','Bold')
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
grid on
axis([0 0.5 -40 10]);

P=2;
y2 = create_prbs(0, 1, 0, N, P, 2^N*P, 0);
NFFT=2^N;
wind=hanning(NFFT/2);
overlap=NFFT/4;
[Py,f]=psd(y2,NFFT,fs,wind,overlap);
mag=10*log10(Py);
subplot(3,1,2),plot(f,mag,'k','linewidth',2);
title('b) PRBS Spectrum: N = 8, p = 2','FontSize',12,'FontWeight','Bold')
set(gca,'XTick',[0.05 0.1 0.15 0.2 0.25 0.30 0.35 0.40 0.45 0.5])
set(gca,'XTickLabel',{'0.05', '0.10', '0.15', '0.20', '0.25', '0.30', '0.35', '0.40','0.45', '0.5'},'FontSize',10,'FontWeight','Bold')
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
grid on
axis([0 0.5 -40 10]);

P=3;
y3 = create_prbs(0, 1, 0, N, P, 2^N*P, 0);
NFFT=2^N;
wind=hanning(NFFT/2);
overlap=NFFT/4;
[Py,f]=psd(y3,NFFT,fs,wind,overlap);
mag=10*log10(Py);
subplot(3,1,3),plot(f,mag,'k','linewidth',2);
title('c) PRBS Spectrum: N = 8, p = 3','FontSize',12,'FontWeight','Bold')
set(gca,'XTick',[0.05 0.1 0.15 0.2 0.25 0.30 0.35 0.40 0.45 0.5])
set(gca,'XTickLabel',{'0.05', '0.10', '0.15', '0.20', '0.25', '0.30', '0.35', '0.40','0.45', '0.5'},'FontSize',10,'FontWeight','Bold')
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold');
axis([0 0.5 -40 10]);

xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold');
grid on